From d6838b5db3680746791d7010923f7f2c47a4994c Mon Sep 17 00:00:00 2001
From: guowenxue <guowenxue@gmail.com>
Date: Fri, 21 Aug 2020 14:06:21 +0800
Subject: [PATCH] Add file build shell script

---
 3rdparty/file/build.sh |   97 ++++++++++++++++++++++++++++++++++++++++++++++++
 1 files changed, 97 insertions(+), 0 deletions(-)

diff --git a/3rdparty/file/build.sh b/3rdparty/file/build.sh
new file mode 100755
index 0000000..f1cddc3
--- /dev/null
+++ b/3rdparty/file/build.sh
@@ -0,0 +1,97 @@
+#!/bin/bash
+
+#+--------------------------------------------------------------------------------------------
+#|Description:  This shell script used download and compile file for ARM
+#|     Author:  GuoWenxue <guowenxue@gmail.com>
+#|  ChangeLog:
+#|           1, Initialize 1.0.0 on 2011.04.12
+#+--------------------------------------------------------------------------------------------
+
+PREFIX_PATH=`pwd`/../install/bin
+
+LYFTP_SRC=ftp://master.iot-yun.club/src/
+
+CROSSTOOL=/opt/xtools/arm920t/bin/arm-linux-
+
+function msg_banner()
+{
+    echo ""
+    echo "+-----------------------------------------------------------------------"
+    echo "|  $1 "
+    echo "+-----------------------------------------------------------------------"
+    echo ""
+}
+
+function check_result()
+{
+    if [ $? != 0 ] ; then
+       echo ""
+       echo "+-----------------------------------------------------------------------"
+       echo "|  $1 "
+       echo "+-----------------------------------------------------------------------"
+       echo ""
+       exit ;
+    fi
+}
+
+function export_cross()
+{
+    # export cross toolchain
+    export CC=${CROSSTOOL}gcc
+    export AS=${CROSSTOOL}as
+    export AR=${CROSSTOOL}ar
+    export LD=${CROSSTOOL}ld
+    export NM=${CROSSTOOL}nm
+    export RANLIB=${CROSSTOOL}ranlib
+    export OBJDUMP=${CROSSTOOL}objdump
+    export STRIP=${CROSSTOOL}strip
+
+    # export cross configure 
+    export CONFIG_CROSS=" --build=i686-pc-linux --host=arm-linux "
+
+    # Clear LDFLAGS and CFLAGS
+    export LDFLAGS=
+    export CFLAGS=
+}
+
+function compile_file()
+{
+    # CentOS 6.0 use file-5.04, so we should cross compile 5.04 for ARM too, for make magic file
+    SRC_NAME=file-5.04
+    PACK_SUFIX=tar.gz
+
+    if [ -f ${PREFIX_PATH}/file ] ; then
+        msg_banner "$SRC_NAME already compile and installed"
+        return 0;
+    fi
+
+    msg_banner "Start cross compile $SRC_NAME "
+
+    if [ ! -f ${SRC_NAME}.${PACK_SUFIX} ] ; then
+        #wget ftp://ftp.astron.com/pub/file/${SRC_NAME}.${PACK_SUFIX}
+        wget ${LYFTP_SRC}/${SRC_NAME}.${PACK_SUFIX}
+        check_result "ERROR: download ${SRC_NAME} failure"
+    fi
+
+    tar -xzf ${SRC_NAME}.${PACK_SUFIX}
+    cd ${SRC_NAME}
+
+    ./configure --prefix=${PREFIX_PATH} ${CONFIG_CROSS} --enable-static --disable-shared
+    check_result "ERROR: configure ${SRC_NAME} failure"
+
+    make 
+    check_result "ERROR: compile ${SRC_NAME} failure"
+
+    ${STRIP} src/file
+    cp src/file ..
+    cp src/file ${PREFIX_PATH} 
+
+    cd -
+}
+
+
+export_cross
+
+compile_file
+
+

--
Gitblit v1.9.1